/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
   USA

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
#include <stdio.h>
#include <errno.h>
#include <time.h>
#include <string.h>
#include <locale.h>
#include <wchar.h>
#include <io.h>
#include "libp.h"
#include <fcntl.h>

int __getmode(int __handle);

int _RTL_FUNC fgetpos(FILE *restrict stream, fpos_t *restrict pos)
{
	if (stream->token == FILTOK) {
        long curpos;
        stream->flags &= ~_F_VBUF;
		if (!(__getmode(stream->fd) & O_BINARY) && fflush(stream))
			return EOF ;            
		curpos = tell(fileno(stream));
		if (curpos < 0) {
			stream->flags |= _F_ERR;
			errno = EIO;
			return EOF;
		}
		if (stream->level > 0 && stream->buffer)
			curpos -= stream->level - 1;
		else			
			if (stream->level < 0 && stream->buffer)
				curpos += stream->bsize + stream->level;
        if (stream->flags & _F_UNGETC)
            curpos--;
        pos->pos = curpos;
        memcpy(pos->mbstate,stream->mbstate,sizeof(pos->mbstate));
		return 0;
	}
	_dos_errno = errno = ENOENT;
	return EOF;
}